<?php
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."database/DbUtilPostgreSQL.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."lang/Variable.php");
/**
 * @author Kazutaka Tokushima
 * @license LGPL
 * @copyright Copyright 2005- The Rhacophorus Project. All rights reserved.
 * @version 0.1.2
 */
class ExtDbUtilPostgreSQL extends DbUtilPostgreSQL{
	function forward($tagDataProjectDatabase){
		$sql			= "";
		$defaultSql	= "";
		
		if(Variable::isClassType(DatabaseModel,$tagDataProjectDatabase)){
			foreach($tagDataProjectDatabase->tableList as $table){
				if(Variable::isClassType(TableModel,$table)){
					$sql			.= sprintf("CREATE TABLE %s (\n",$table->getTableName());
					$columnSql		= "";
					$primarySql		= "";
					$referenceSql	= "";
					
					foreach($table->columnList as $column){
						if(Variable::isClassType(ColumnModel,$column)){
							if(!empty($columnSql)){
								$columnSql .= "\t,";
							}
							$columnSql .= sprintf("%s",$column->name);
							
							if(preg_match("/(serial)/i",$column->type)){
								$type = "SERIAL";
								if($column->size > 9){
									$type = "BIGSERIAL";
								}
								$columnSql .= sprintf(" %s",$type);
							}else if(preg_match("/(int)/i",$column->type)){
								$type = "INTEGER";								
								if($column->size > 9){
									$type = "NUMERIC";
								}
								$columnSql .= sprintf(" %s",$type);
							}else if(preg_match("/(timestamp)/i",$column->type)){
								$type = "TIMESTAMP";
								$columnSql .= sprintf(" %s",$type);								
							}else if(preg_match("/(string)/i",$column->type)){
								if($column->size > 0){
									$type = "VARCHAR";
									$columnSql .= sprintf(" %s",$type);
									$columnSql .= sprintf("(%d)",$column->size);
								}else{
									$type = "TEXT";
									$columnSql .= sprintf(" %s",$type);
								}
							}else if(preg_match("/(bool)/i",$column->type)){
								$type = "BIT";
								$columnSql .= sprintf(" %s",$type);
							}
							if($column->require){
								$columnSql .= sprintf(" NOT NULL");
							}
							if($column->default != ""){
								$columnSql .= sprintf(" DEFAULT");

								if(preg_match("/(string)/i",$column->type)){
									$columnSql .= sprintf(" '%s'",$column->default);
								}else if(preg_match("/(timestamp)/i",$column->type) || preg_match("/sysdate/i",$column->default)){
									$columnSql .= sprintf(" 'now'");
								}else if(preg_match("/(bool)/i",$column->type)){
									$columnSql .= sprintf(" 'B%s'",intval(Variable::getBoolean($column->default)));									
								}else{
									$columnSql .= sprintf(" %s",$column->default);
								}
							}
							$columnSql .= "\n";
						}
					}
					foreach($table->primaryList as $column){
						if(!empty($primarySql)){
							$primarySql .= ",";
						}
						$primarySql .= sprintf("%s",$column->name);
					}
					$sql	 .= sprintf("\t %s",$columnSql);
					
					if(!empty($primarySql)){
						$sql .= sprintf("\t,PRIMARY KEY(%s)\n",$primarySql);
					}
					$sql .= sprintf(");\n\n");
					
					foreach($table->defaultList as $defaults){
						$columnString	= "";
						$valueString		= "";		
						
						foreach($table->columnList as $column){
							if($column->type != "SERIAL"){
								$value = $column->default;
	
								foreach($defaults as $default){
									if($default->column == $column->name){
										$value = $default->value;
										break;
									}
								}
								$value = $this->_getValueString($column,$value);

								$columnString	.= sprintf(",%s",$column->name);
								$valueString		.= sprintf(",%s",$value);
							}
						}
						$defaultSql .= sprintf("insert into %s(%s) values(%s);\n",$table->getTableName(),substr($columnString,1),substr($valueString,1));
					}
				}
			}
			foreach($tagDataProjectDatabase->tableList as $table){
				if(Variable::isClassType(TableModel,$table)){
					foreach($table->referenceList as $reference){
						$sql .= sprintf("ALTER TABLE %s ADD CONSTRAINT %s FOREIGN KEY (%s) REFERENCES %s(%s);\n",
													$reference->table,
													sprintf("FK_%s_%s",$reference->table,$reference->column),
													$reference->column,
													$reference->referenceTableReal,
													$reference->referenceColumn
									);
					}
				}
			}
			$sql = sprintf("%s\n\n%s",$sql,$defaultSql);
		}
		return $sql;
	}
	function _getColumnTypeValue($value){
		if(preg_match("/(char)|(text)/i",$value)){
			return "STRING";
		}else if(preg_match("/int/i",$value)){
			return "INTEGER";
		}else if(preg_match("/(date)|(time)/i",$value)){
			return "TIMESTAMP";
		}
		return "STRING";
	}

}
?>