<?php
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."tag/data/Tag.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."tag/feed/data/AtomEntry.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."lang/DateUtil.php");
/**
 * @author Kazutaka Tokushima
 * @license LGPL
 * @copyright Copyright 2006- The Rhacophorus Project. All rights reserved.
 * @version 0.1.1
 */
class AtomEntry03 extends AtomEntry{
	var $author = "";
	var $modified = "";
	var $issued = "";
	var $id = "";
	var $created = "";

	function _set($tag){
		parent::_set($tag);

		foreach($tag->getIn("author") as $intag){
			$data = new AtomAuthor();
			$data->set($intag->get());
			$this->setAuthor($data);
		}
		foreach($tag->getIn("modified") as $intag){
			$this->setModified($intag->getValue());
		}
		foreach($tag->getIn("issued") as $intag){
			$this->setIssued($intag->getValue());
		}
		foreach($tag->getIn("id") as $intag){
			$this->setId($intag->getValue());
		}
		foreach($tag->getIn("created") as $intag){
			$this->setCreated($intag->getValue());
		}
	}
	function _get($outTag){
		$tag		= new Tag("modified",$this->getModified());
		$outTag->addValue($tag->get()."\n");
		$tag		= new Tag("issued",$this->getIssued());
		$outTag->addValue($tag->get()."\n");
		$tag		= new Tag("id",$this->getId());
		$outTag->addValue($tag->get()."\n");
		$tag		= new Tag("created",$this->getCreated());
		$outTag->addValue($tag->get()."\n");

		$data = $this->getAuthor();
		$outTag->addValue($data->get()."\n");		
				
		return parent::_get($outTag);
	}
	
	function setModified($value){
		$this->modified = DateUtil::parseString($value);
	}
	function getModified(){
		return $this->modified;
	}
	function setIssued($value){
		$this->issued = $value;
	}
	function getIssued(){
		return $this->issued;
	}
	function setCreated($value){
		$this->created = DateUtil::parseString($value);
	}
	function getCreated(){
		return $this->created;
	}
	function setId($value){
		$this->id = $value;
	}
	function getId(){
		return $this->id;
	}
	
	function setAuthor($value){
		$this->author = $value;
	}
	function getAuthor(){
		return $this->author;
	}
}